#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GrandPrixRankingCFG.h"
std::auto_ptr<Fish_GrandPrixRankingCFG> Fish_GrandPrixRankingCFG::msSingleton(nullptr);

int Fish_GrandPrixRankingCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GrandPrixRankingCFGData* Fish_GrandPrixRankingCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GrandPrixRankingCFGData>& Fish_GrandPrixRankingCFG::GetMapData()
{
	return mMapData;
}

void Fish_GrandPrixRankingCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GrandPrixRankingCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GrandPrixRankingCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mRankingType = element->IntAttribute("RankingType");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GrandPrixRankingCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GrandPrixRankingCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GrandPrixRankingCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GrandPrixRankingCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GrandPrixRankingCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "RankingType", data.mRankingType);
		LuaCfgHelper::readInt(L, "StartRank", data.mStartRank);
		LuaCfgHelper::readInt(L, "EndRank", data.mEndRank);
		LuaCfgHelper::readVectorInt(L, "RewardList", data.mRewardList);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GrandPrixRankingCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GrandPrixRankingCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GrandPrixRankingCFG* Fish_GrandPrixRankingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GrandPrixRankingCFG());
	}
	return msSingleton.get();
}

void Fish_GrandPrixRankingCFG::Release()
{
	msSingleton.reset(nullptr);
}
